package com.zcloud.personnel.positioning.command;

import com.zcloud.personnel.positioning.domain.gateway.AlarmRecordTargetGateway;
import com.zcloud.personnel.positioning.domain.model.AlarmRecordTargetE;
import com.zcloud.personnel.positioning.dto.AlarmRecordTargetAddCmd;
import com.alibaba.cola.exception.BizException;
import lombok.AllArgsConstructor;
import org.springframework.beans.BeanUtils;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;

/**
 * web-app
 *
 * @Author fangjiakai
 * @Date 2026-07-07
 */
@Component
@AllArgsConstructor
public class AlarmRecordTargetAddExe {
    private final AlarmRecordTargetGateway alarmRecordTargetGateway;

    @Transactional(rollbackFor = Exception.class)
    public boolean execute(AlarmRecordTargetAddCmd cmd) {
        AlarmRecordTargetE alarmRecordTargetE = new AlarmRecordTargetE();
        BeanUtils.copyProperties(cmd, alarmRecordTargetE);
        boolean res;
        try {
            res = alarmRecordTargetGateway.add(alarmRecordTargetE);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }
        if (!res) {
            throw new BizException("保存失败");
        }
        return true;
    }
}
